# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::Reservations::Mgmt::V2019_04_01_preview
  module Models
    #
    # Information describing the type of billing plan for this reservation.
    #
    class ReservationOrderBillingPlanInformation

      include MsRestAzure

      # @return [Price] Amount of money to be paid for the Order. Tax is not
      # included.
      attr_accessor :pricing_currency_total

      # @return [Date] Date when the billing plan has started.
      attr_accessor :start_date

      # @return [Date] For recurring billing plans, indicates the date when
      # next payment will be processed. Null when total is paid off.
      attr_accessor :next_payment_due_date

      # @return [Array<PaymentDetail>]
      attr_accessor :transactions


      #
      # Mapper for ReservationOrderBillingPlanInformation class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'ReservationOrderBillingPlanInformation',
          type: {
            name: 'Composite',
            class_name: 'ReservationOrderBillingPlanInformation',
            model_properties: {
              pricing_currency_total: {
                client_side_validation: true,
                required: false,
                serialized_name: 'pricingCurrencyTotal',
                type: {
                  name: 'Composite',
                  class_name: 'Price'
                }
              },
              start_date: {
                client_side_validation: true,
                required: false,
                serialized_name: 'startDate',
                type: {
                  name: 'Date'
                }
              },
              next_payment_due_date: {
                client_side_validation: true,
                required: false,
                serialized_name: 'nextPaymentDueDate',
                type: {
                  name: 'Date'
                }
              },
              transactions: {
                client_side_validation: true,
                required: false,
                serialized_name: 'transactions',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'PaymentDetailElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'PaymentDetail'
                      }
                  }
                }
              }
            }
          }
        }
      end
    end
  end
end
