# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::Reservations::Mgmt::V2019_07_19_preview
  module Models
    #
    # Quota properties for the resource.
    #
    class QuotaProperties

      include MsRestAzure

      # @return [Integer] The quota limit.
      attr_accessor :limit

      # @return [Integer] The current resource usages information.
      attr_accessor :current_value

      # @return [String]  The units of the limit, such as - Count, Bytes, etc.
      # Use the unit field provided in the Get quota response.
      attr_accessor :unit

      # @return [ResourceName] Name of the resource provide by the resource
      # Provider. Please use this name property for quotaRequests.
      attr_accessor :name

      # @return The Resource Type Name.
      attr_accessor :resource_type

      # @return [String] The quota period over which the usage values are
      # summarized, such as - P1D (Per one day), PT1M (Per one minute), PT1S
      # (Per one second). This parameter is optional because, for some
      # resources like compute, the period doesn’t matter.
      attr_accessor :quota_period

      # @return Additional properties for the specific resource provider.
      attr_accessor :properties


      #
      # Mapper for QuotaProperties class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'QuotaProperties',
          type: {
            name: 'Composite',
            class_name: 'QuotaProperties',
            model_properties: {
              limit: {
                client_side_validation: true,
                required: false,
                serialized_name: 'limit',
                type: {
                  name: 'Number'
                }
              },
              current_value: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'currentValue',
                type: {
                  name: 'Number'
                }
              },
              unit: {
                client_side_validation: true,
                required: false,
                serialized_name: 'unit',
                type: {
                  name: 'String'
                }
              },
              name: {
                client_side_validation: true,
                required: false,
                serialized_name: 'name',
                type: {
                  name: 'Composite',
                  class_name: 'ResourceName'
                }
              },
              resource_type: {
                client_side_validation: true,
                required: false,
                serialized_name: 'resourceType',
                type: {
                  name: 'Object'
                }
              },
              quota_period: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'quotaPeriod',
                type: {
                  name: 'String'
                }
              },
              properties: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties',
                type: {
                  name: 'Object'
                }
              }
            }
          }
        }
      end
    end
  end
end
